#--------------------------------------------------------------------------------
#   If you want to ignore a bunch of non-eseential stuff then
#      S C R O L L   A L M O S T  H A L F   W A Y  D O W N
#--------------------------------------------------------------------------------
#TradingSimula18.py - programmed by George Pruitt
#Built on the code and ideas from "The Ultimate Algorithmic Tradins System T-Box"
#Code is broken into sections
#Most sections can and should be ignored
#Each trading algorithm must be programmed with this template
#This is the main entry into the platform
#--------------------------------------------------------------------------------
#Import Section - inlcude functions, classes, variables from external modules
#--------------------------------------------------------------------------------
# --- Do  not change below here
from getData import getData
from equityDataClass import equityClass
from tradeClass import tradeInfo
from systemMarket import systemMarketClass
from indicators import highest,lowest,rsiClass,stochClass,sAverage,bollingerBands
from indicators import keltnerChannels,linearRegression
from portfolio import portfolioClass
from systemAnalytics import calcSystemResults
from utilityFunctions import getDataAtribs,getDataLists,roundToNearestTick,calcTodaysOTE
from utilityFunctions import setDataLists,removeDuplicates
from portManager import portManagerClass,systemMarkTrackerClass
from positionMatrixClass import positionMatrixClass
from barCountCalc import barCountCalc

from sectorClass import sectorClass, parseSectors, numPosCurrentSector
#-------------------------------------------------------------------------------------------------
# Pay no attention to these two functions - unless you want to
#-------------------------------------------------------------------------------------------------
def exitPos(myExitPrice,myExitDate,tempName,myCurShares):
    global tradeName,entryPrice,entryQuant,exitPrice,numShares,myBPV,cumuProfit
    if mp < 0:
        trades = tradeInfo('liqShort',myExitDate,tempName,myExitPrice,myCurShares,0)
        profit = trades.calcTradeProfit('liqShort',mp,entryPrice,myExitPrice,entryQuant,myCurShares) * myBPV
        profit = profit - myCurShares *commission;trades.tradeProfit = profit;cumuProfit += profit
        trades.cumuProfit = cumuProfit
    if mp > 0:
        trades = tradeInfo('liqLong',myExitDate,tempName,myExitPrice,myCurShares,0)
        profit = trades.calcTradeProfit('liqLong',mp,entryPrice,myExitPrice,entryQuant,myCurShares) * myBPV
        profit = profit - myCurShares * commission;trades.tradeProfit = profit;cumuProfit += profit
        trades.cumuProfit = cumuProfit
    curShares = 0
    for remShares in range(0,len(entryQuant)):curShares += entryQuant[remShares]
    return (profit,trades,curShares)

def bookTrade(entryOrExit,lOrS,price,date,tradeName,shares):
    global mp,commission,totProfit,curShares,barsSinceEntry,listOfTrades
    global entryPrice,entryQuant,exitPrice,numShares,myBPV,cumuProfit
    if entryOrExit == -1:
        profit,trades,curShares = exitPos(price,date,tradeName,shares);mp = 0
    else:
        profit = 0;curShares = curShares + shares;barsSinceEntry = 1;entryPrice.append(price);entryQuant.append(shares)
        if lOrS == 1:mp += 1;trades = tradeInfo('buy',date,tradeName,entryPrice[-1],shares,1)
        if lOrS ==-1:mp -= 1;trades = tradeInfo('sell',date,tradeName,entryPrice[-1],shares,1)
    return(profit,curShares,trades)

dataClassList = list()

marketMonitorList,masterDateList,masterDateGlob,entryPrice = ([] for i in range(4))
buy = entry = 1; sell = exit = -1; ignore = 0;
entryQuant,exitQuant,trueRanges,myBPVList = ([] for i in range(4))
myComNameList,myMinMoveList,systemMarketList = ([] for i in range(3))
firstMarketLoop = True
portManager = portManagerClass();marketList = getData();portfolio = portfolioClass()
numMarkets = len(marketList);positionMatrix = positionMatrixClass();positionMatrix.numMarkets = numMarkets
cond1,cond2,cond3,cond4 = ([] for i in range(4))
marketVal1,marketVal2,marketVal3,marketVal4 = ([] for i in range(4))
marketVal1List = list()

#----------------------------------------------------------------------------------
# Set up algo parameters here
#----------------------------------------------------------------------------------
startTestDate = 20000101 #must be in yyyymmdd
stopTestDate = 99999999 #must be in yyyymmdd
rampUp = 100 # need this minimum of bars to calculate indicators
sysName = 'TF-SwingBO' #System Name here
initCapital = 500000
commission = 50

#----------------------------------------------------------------------------------
# Remember if you need to keep track of variables from one market to another
# you will need to create list variables instead of scalar variables
# a small price to pay to scale horizontally -
# I have set up marketVal1 thru marketVal4 and cond1 thru cond4, but you can do
# more here too!  Here is an example
# userVar1,userVar2,userVar3,userVar4 = ([] for i in range(4))
# You will then need to fill them with zeros
# userVar1 = [0 for i in range(numMarkets)]

lastSwing,swingHi,swingHiBar,swingLo,swingLoBar = ([] for i in range(5))
curHi,curHiBar,curLo,curLoBar = ([] for i in range(4))
lastSwing = [0 for i in range(numMarkets)]
swingHi = [0 for i in range(numMarkets)]
swingHiBar = [0 for i in range(numMarkets)]
swingLo = [0 for i in range(numMarkets)]
swingLoBar = [0 for i in range(numMarkets)]
curHi = [0 for i in range(numMarkets)]
curHiBar = [0 for i in range(numMarkets)]
curLo = [0 for i in range(numMarkets)]
curLoBar = [0 for i in range(numMarkets)]


#---------------------------------------------------------------------------------
# Do not change code below
#---------------------------------------------------------------------------------
dailyPortCombEqu = 0
curShares = 0
myOHLCTR = list()
for curMarket in range(0,numMarkets):
    systemMarkTracker = systemMarkTrackerClass()
    equity = equityClass()
    systemMarkTracker.setSysMarkTrackingData(marketList[curMarket])
    systemMarkTracker.setSysMarkTrackingEquity(equity)
    marketMonitorList.append(systemMarkTracker)
    myBPV,myComName,myMinMove= getDataAtribs(marketMonitorList[curMarket].marketData)
    myBPVList.append(myBPV);myComNameList.append(myComName);myMinMoveList.append(myMinMove)
    cond1.append(0);cond2.append(0);cond3.append(0),cond4.append(0)
    marketVal1.append(0);marketVal2.append(0);marketVal3.append(0),marketVal4.append(0)


sectorList = list()
numSectors = 7
for sector in range(0,numSectors):
    sectors = sectorClass()
    if sector == 0 : sectors.assignSectors("Currency","BPSFADDXECJYCD",myComNameList)
    if sector == 1 : sectors.assignSectors("Energies","CLHONGRB",myComNameList)
    if sector == 2 : sectors.assignSectors("Metals","GCSIHGPLPA",myComNameList)
    if sector == 3 : sectors.assignSectors("Grains","S_W_C_BOSMRR",myComNameList)
    if sector == 4 : sectors.assignSectors("Financials","USTYTUFVED",myComNameList)
    if sector == 5 :  sectors.assignSectors("Softs","SBKCCCCTLBOJ",myComNameList)
    if sector == 6 :sectors.assignSectors("Meats","LCLHFC",myComNameList)
    sectorList.append(sectors)

for i in range(0,len(sectorList)):
    if sectorList[i].sectMarket != []: print(sectorList[i].sectMarket)


masterDateGlob = list()

for curMarket in range(0,numMarkets):
    numDaysInData = len(marketMonitorList[curMarket].marketData.date)
    masterDateGlob += marketMonitorList[curMarket].marketData.date
    positionMatrix.marketNames.append(myComNameList[curMarket])
masterDateList = removeDuplicates(masterDateGlob);masterDateList = sorted(masterDateList)
barCount, endBarCount = barCountCalc(masterDateList,startTestDate,stopTestDate,rampUp)
portEquItm = barsSinceEntry = 0;dailyPortCombEqu = initCapital

for curPortBar in range(barCount,endBarCount+1):
    portManager.portDate.append(masterDateList[curPortBar])
    if curPortBar % 225 == 0 : print("Working on bar #: ",curPortBar)
    for curMarket in range(0,numMarkets):
        if curMarket == 0 : indivMktAccum = initCapital
        myOHLCTR.clear()
        myDate,myOpen,myHigh,myLow,myClose,myVolume,myOpInt,myRange,myTrueRange = setDataLists(marketMonitorList[curMarket].marketData)
        myOHLCTR.append(myOpen);myOHLCTR.append(myHigh);myOHLCTR.append(myLow);
        myOHLCTR.append(myClose);myOHLCTR.append(myTrueRange)
        equItm = marketMonitorList[curMarket].equItm
        equItm += 1
        myBPV = myBPVList[curMarket];myComName = myComNameList[curMarket];myMinMove = myMinMoveList[curMarket]
        if myComName not in portManager.marketSymbols:
            portManager.marketSymbols.append(myComName)
            portManager.numConts.append(1)
        curShares = 0;todaysCTE = todaysOTE = 0;mktsToday = 0

        if masterDateList[curPortBar] in marketMonitorList[curMarket].marketData.date:
            if firstMarketLoop: firstBar = True
            curBar = marketMonitorList[curMarket].marketData.date.index(masterDateList[curPortBar])
            numSectorPositions = numPosCurrentSector(sectorList,myComName,myComNameList,positionMatrix.posMatrixSize[-numMarkets:])
            numSectorPositions = 0
            mp = 0
            if len(marketMonitorList[curMarket].mp)!=0: mp = marketMonitorList[curMarket].mp[-1]
            entryPrice = marketMonitorList[curMarket].entryPrice
            entryQuant= marketMonitorList[curMarket].entryQuant
            curShares = marketMonitorList[curMarket].curShares
            cumuProfit = marketMonitorList[curMarket].cumuProfit
            barsSinceEntry = marketMonitorList[curMarket].barsSinceEntry
#---------------------------------------------------------------------------------------------------
#  Start programming your great trading ideas below here - don't touch stuff above
#---------------------------------------------------------------------------------------------------
#  Define Long, Short, ExitLong and ExitShort Levels - mind your indentations
            xHi = myHigh[curBar]
            xLo = myLow[curBar]

            perSwing = 0.05
            cm = curMarket
            if firstBar == True:
                curHi[cm] = myClose[curBar]
                curLo[cm] = myClose[curBar]

            if lastSwing[cm] != 1:
                if xLo < curHi[cm] - curHi[cm] * perSwing:
                    lastSwing[cm] = 1
                    swingHi[cm] = curHi[cm]
                    swingHiBar[cm] = curHiBar[cm]
                    curLo[cm] = xLo
                    curLoBar[cm] = curBar
#                    print(myDate[curBar]," ",myComName," Swing Hi ",swingHi[cm]," ",swingHiBar[cm]," ",curBar)
                else:
                    if xHi > curHi[cm]:
                        curHi[cm]= xHi
                        curHiBar[cm] = curBar

            if lastSwing[cm] != -1:
                if xHi > curLo[cm] + curLo[cm] * perSwing:
                    lastSwing[cm] = -1
                    swingLo[cm] = curLo[cm]
                    swingLoBar[cm] = curLoBar[cm]
                    curHi[cm] = xHi
                    curHiBar[cm] = curBar
#                    print(myDate[curBar]," ",myComName," Swing Lo ",swingLo[cm]," ",swingLoBar[cm]," ",curBar)
                else:
                    if xLo < curLo[cm]:
                        curLo[cm] = xLo
                        curLoBar[cm] = curBar


#            print(myDate[curBar]," ",myComName," ",lastSwing[curMarket]," ",swingHi[curMarket]," ",swingLo[curMarket])
            ATR = sAverage(myTrueRange,30,curBar,1)

            shortExit = longExit = 0
            if mp == 1: longExit   = roundToNearestTick(entryPrice[-1] - 3*ATR,-1,myMinMove)
#            if mp == 1: print(myDate[curBar]," ",longExit," ",entryPrice[-1])
            if mp ==-1: shortExit  = roundToNearestTick(entryPrice[-1] + 3*ATR,1,myMinMove)
            sum1 = sum2 = 0
            posSize = 1
#  Long Entry
#  Okay  Let's put in some logic to create a long position
            if myHigh[curBar-1] > swingHi[cm] and ATR*myBPV < 2000 and mp !=1:
                price = myOpen[curBar]
                tradeName = "TF-Swing-B"
                numShares = posSize
                if mp <= -1:
                    profit,curShares,trades = bookTrade(-1,0,price,myDate[curBar],"RevshrtLiq",curShares)
                    marketMonitorList[curMarket].tradesList.append(trades);todaysCTE = profit
                profit,curShares,trades = bookTrade(entry,buy,price,myDate[curBar],tradeName,numShares)
                barsSinceEntry = 1
                marketMonitorList[curMarket].setSysMarkTrackingInfo(tradeName,cumuProfit,mp,barsSinceEntry,curShares,trades)
#  Long Exit
            if mp == 1 and myLow[curBar] <= longExit and barsSinceEntry > 1:
                price = min(myOpen[curBar],longExit)
                tradeName = "Lxit"
                numShares = curShares
                profit,curShares,trades = bookTrade(exit,ignore,price,myDate[curBar],tradeName,numShares)
                todaysCTE = profit;barsSinceEntry = 0
                marketMonitorList[curMarket].setSysMarkTrackingInfo(tradeName,cumuProfit,mp,barsSinceEntry,curShares,trades)

            if  mp == 1 and myLow[curBar-1] < swingLo[cm] and ATR*myBPV >= 1000 and barsSinceEntry > 1:
                price = myOpen[curBar]
                tradeName = "Lxit2Risky"
                numShares = curShares
                profit,curShares,trades = bookTrade(exit,ignore,price,myDate[curBar],tradeName,numShares)
                todaysCTE = profit;barsSinceEntry = 0
                marketMonitorList[curMarket].setSysMarkTrackingInfo(tradeName,cumuProfit,mp,barsSinceEntry,curShares,trades)


#  Short Entry
#  Okay  Let's put in some logic to create a short position
            if myLow[curBar-1] < swingLo[cm] and ATR*myBPV < 2000 and mp !=-1:
                price = myOpen[curBar]
                tradeName = "TF-Swing-S"
                numShares = posSize
                if mp >= 1:
                    profit,curShares,trades = bookTrade(-1,0,price,myDate[curBar],"RevLongLiq",curShares)
                    marketMonitorList[curMarket].tradesList.append(trades);todaysCTE = profit
                profit,curShares,trades = bookTrade(entry,sell,price,myDate[curBar],tradeName,numShares)
                barsSinceEntry = 1
                marketMonitorList[curMarket].setSysMarkTrackingInfo(tradeName,cumuProfit,mp,barsSinceEntry,curShares,trades)
#  Short Exit
            if mp == -1 and myHigh[curBar] >= shortExit and barsSinceEntry > 1:
                price = max(myOpen[curBar],shortExit)
                tradeName = "Sxit"
                numShares = curShares
                profit,curShares,trades = bookTrade(exit,ignore,price,myDate[curBar],tradeName,numShares)
                todaysCTE = profit;barsSinceEntry = 0
                marketMonitorList[curMarket].setSysMarkTrackingInfo(tradeName,cumuProfit,mp,barsSinceEntry,curShares,trades)

            if  mp == -1 and myHigh[curBar-1] > swingHi[cm] and ATR*myBPV >= 1000 and barsSinceEntry > 1:
                price = myOpen[curBar]
                tradeName = "Sxit2Risky"
                numShares = curShares
                profit,curShares,trades = bookTrade(exit,ignore,price,myDate[curBar],tradeName,numShares)
                todaysCTE = profit;barsSinceEntry = 0
                marketMonitorList[curMarket].setSysMarkTrackingInfo(tradeName,cumuProfit,mp,barsSinceEntry,curShares,trades)

###----------------------------------------------------------------------------------------------------------------------------
# - Do not change code below - trade, portfolio accounting - our great idea should stop here
#----------------------------------------------------------------------------------------------------------------------------
            if mp != 0 :barsSinceEntry += 1;todaysOTE = calcTodaysOTE(mp,marketList[curMarket].close[curBar],marketMonitorList[curMarket].entryPrice,marketMonitorList[curMarket].entryQuant,myBPV)
            marketMonitorList[curMarket].barsSinceEntry = barsSinceEntry
            marketMonitorList[curMarket].curShares = curShares
            marketMonitorList[curMarket].equItm = equItm
            marketMonitorList[curMarket].equity.setEquityInfo(marketList[curMarket].date[curBar],equItm,todaysCTE,todaysOTE)
            portManager.individEquity.append((curMarket,marketMonitorList[curMarket].equity.dailyEquityVal[-1]))
            indivMktAccum += portManager.individEquity[portEquItm][1]
            portEquItm += 1
            if curPortBar == endBarCount:
                if mp >= 1:
                    price = marketList[curMarket].close[curBar]
                    exitDate = marketList[curMarket].date[curBar]
                    profit,trades,curShares = exitPos(price,marketList[curMarket].date[curBar],"L-EOD",curShares)
                    marketMonitorList[curMarket].tradesList.append(trades)
                if mp <= -1:
                    price = marketList[curMarket].close[curBar]
                    exitDate = marketList[curMarket].date[curBar]
                    profit,trades,curShares = exitPos(price,marketList[curMarket].date[curBar],"S-EOD",curShares)
                    marketMonitorList[curMarket].tradesList.append(trades)
        else:
            equityStreamLen = len(marketMonitorList[curMarket].equity.dailyEquityVal)
            if equityStreamLen > 0: portManager.individEquity.append((curMarket,marketMonitorList[curMarket].equity.dailyEquityVal[-1]))
            else: portManager.individEquity.append((curMarket,0.0))
            indivMktAccum += portManager.individEquity[portEquItm][1]
            portEquItm += 1
#        firstBar = False
    if curMarket == numMarkets - 1 and firstMarketLoop:
        firstMarketLoop = False
        firstBar = False
    dailyPortCombEqu = indivMktAccum
    portManager.combinedEquity.append(dailyPortCombEqu)
    positionMatrix.posMatrixDate.append(masterDateList[curPortBar])
    for mktCnt in range(0,len(marketMonitorList)):
        positionMatrix.posMatrixSize.append(marketMonitorList[mktCnt].curShares)
cnt = 0
for j in range(0,numMarkets):
    systemMarket = systemMarketClass()
    systemMarket.setSysMarkInfo(sysName,myComNameList[j],marketMonitorList[j].tradesList,marketMonitorList[j].equity,initCapital)
    systemMarketList.append(systemMarket)
#sectors.setSectorsInfo(numSectors,systemMarketList)
positionMatrix.printPositionMatrix(systemMarketList,portManager)
portfolio.setPortfolioInfo("PortfolioTest",systemMarketList)
parseSectors(sectorList,systemMarketList)
#plotEquityCurve(portfolio)
calcSystemResults(systemMarketList)
